VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "VB to DPLOT Interface Example"
   ClientHeight    =   5175
   ClientLeft      =   2190
   ClientTop       =   2700
   ClientWidth     =   3120
   BeginProperty Font 
      Name            =   "MS Sans Serif"
      Size            =   8.25
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H80000008&
   LinkTopic       =   "Form1"
   NegotiateMenus  =   0   'False
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   5175
   ScaleWidth      =   3120
   Begin VB.CheckBox Check1 
      Caption         =   "&Use DPlot_AddData"
      Height          =   255
      Left            =   240
      TabIndex        =   0
      Top             =   1920
      Width           =   2175
   End
   Begin VB.TextBox Text2 
      Height          =   375
      Left            =   1920
      TabIndex        =   3
      Text            =   "Text2"
      Top             =   3180
      Width           =   615
   End
   Begin VB.Timer Timer1 
      Left            =   2160
      Top             =   4440
   End
   Begin VB.CommandButton RealTimeButton 
      BackColor       =   &H80000005&
      Caption         =   "&Start"
      Height          =   435
      Left            =   120
      TabIndex        =   1
      Top             =   3120
      Width           =   735
   End
   Begin VB.TextBox Text1 
      Height          =   435
      Left            =   120
      TabIndex        =   5
      Top             =   3960
      Width           =   2535
   End
   Begin VB.Label Label7 
      Caption         =   "(See Timer1_Timer() for more info)"
      Height          =   495
      Left            =   240
      TabIndex        =   10
      Top             =   2280
      Width           =   2655
   End
   Begin VB.Label Label6 
      Caption         =   $"btest3.frx":0000
      Height          =   1575
      Left            =   120
      TabIndex        =   9
      Top             =   120
      Width           =   2895
   End
   Begin VB.Label Label5 
      Caption         =   "sec."
      Height          =   255
      Left            =   2640
      TabIndex        =   8
      Top             =   3240
      Width           =   375
   End
   Begin VB.Label Label4 
      Alignment       =   1  'Right Justify
      Caption         =   "Time step:"
      Height          =   255
      Left            =   840
      TabIndex        =   2
      Top             =   3240
      Width           =   975
   End
   Begin VB.Label Label3 
      Height          =   255
      Left            =   840
      TabIndex        =   7
      Top             =   4560
      Width           =   1095
   End
   Begin VB.Label Label2 
      Caption         =   "Time:"
      Height          =   255
      Left            =   120
      TabIndex        =   6
      Top             =   4560
      Width           =   615
   End
   Begin VB.Label Label1 
      Caption         =   "&Plot Window:"
      Height          =   255
      Left            =   120
      TabIndex        =   4
      Top             =   3720
      Width           =   1335
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Option Base 0
Private Declare Function GetTickCount Lib "kernel32" () As Long
Dim DrawMethod As Long
Dim hwndDPlot As Long
Dim DocNum As Long
Dim WasActive As Long
Dim StartTicks As Long
Dim TimeStep As Single
Dim sExec As String

Private Sub Form_Load()
    Dim cx As Integer
    Dim cy As Integer
    Dim x As Integer
    Dim y As Integer
    Dim ret As Integer
    Dim lprc As RECT
    
    '   Initial time step = 0.1 seconds
    TimeStep = 0.1
    Text2.Text = Str$(TimeStep)
    DrawMethod = 0      ' Use DPlot_Command to send data values
    Check1.Value = DrawMethod
    
'   Plotting window is initially 1 minute wide:
    Text1.Text = "0.,-1.5,60.,1.5"

    Timer1.Enabled = False
    Label2.Visible = False
    Label3.Visible = False
    
    '   Set form position to upper-left corner of screen and make it stay-on-top
    ret = SetWindowPos(Me.hwnd, -1, 0, 0, 0, 0, SWP_NOSIZE)

'
'   Ideally DPLOTLIB.DLL should reside in the same folder as your
'   compiled executable. Within the VB environment, though, finding
'   DPLOTLIB.DLL is a bit more problematic. The subroutine DPlot_FindDPLOTLIB
'   will search the registry for its location, then change the
'   working directory to that folder so that VB (actually Windows) will
'   find it.
'
    Call DPlot_FindDPLOTLIB

    ' Start DPlot
    hwndDPlot = DPlot_Start(0, WasActive)
    ' Move DPlot to upper right corner of screen, sized so that both our form
    ' and DPlot are completely visible
    ret = GetWindowRect(Me.hwnd, lprc)
    cx = (Screen.Width / Screen.TwipsPerPixelX) - lprc.Right
    x = lprc.Right
    y = 0
    cy = (Screen.Height / Screen.TwipsPerPixelY)
    If IsZoomed(hwndDPlot) <> 0 Then
        ret = ShowWindow(hwndDPlot, SW_RESTORE)
    End If
    ret = MoveWindow(hwndDPlot, x, y, cx, cy, 1)

    ' Use MessageBox to report errors
    Call DPlot_SetErrorMethod(2)
    
End Sub

Private Sub RealTimeStop()
    Dim ret As Long
    
    Timer1.Enabled = False
    ' Recalculate mins, maxes, means, etc., redraw the plot, and re-enable menu updates
    ret = DPlot_Command(DocNum, "[DeferMinMaxCheck(0)][MenuUpdates(1)]")
    Call DPlot_Disconnect
    Label2.Visible = False
    Label3.Visible = False
    
    RealTimeButton.Caption = "&Start"
End Sub

Private Sub RealTimeButton_Click()
    Dim i As Long
    Dim N As Long
    Dim ret As Long
    Dim rc As RECT

'   If the timer is enabled, we're already running the simulation and user
'   clicked this button to stop the simulation:
    If Timer1.Enabled = True Then
        Call RealTimeStop
        Exit Sub
    End If
    
'   Get timestep
    TimeStep = Val(Text2.Text)
    Timer1.Interval = 1000 * TimeStep

'   Drawing method (see Timer1_Timer)
    DrawMethod = Check1.Value
    
'   Change button caption to indicate that clicking it again stops the simulation,
'   and make the time display visible
    RealTimeButton.Caption = "&Stop"
    Label2.Visible = True
    Label3.Visible = True
    
'   If DPlot is already running, bring it to the top in case user might have
'   minimized it.
    If (IsWindow(hwndDPlot) <> 0) Then
        If (IsIconic(hwndDPlot) <> 0) Then
            ret = ShowWindow(hwndDPlot, SW_RESTORE)
        Else
            ret = BringWindowToTop(hwndDPlot)
        End If
    End If
    
'   Create an empty document window in DPlot and get the document index, which will
'   be used for all subsequent DPlot_Command command strings.
    DocNum = DPlot_Command(0, "[FileNew()]")
    
'   Instruct DPLOT to allocate space for 2 curves, 1 hour's
'   worth of data:
    N = 3600000 / Timer1.Interval
    ret = DPlot_Command(DocNum, "[FileArrays(2," + Str$(N) + ")]")

'   Use thick (.04") lines to push DPLOT's performance limits
    sExec = "[LineWidth(1,40)]"
    sExec = sExec + "[LineWidth(2,40)]"
    sExec = sExec + "[LineType(1," + Str$(LINESTYLE_SOLID) + ")]"
    sExec = sExec + "[LineType(2," + Str$(LINESTYLE_SOLID) + ")]"
    sExec = sExec + "[Color(1,255,0,0)]"
    sExec = sExec + "[Color(2,0,0,255)]"
    ret = DPlot_Command(DocNum, sExec)

    ' Set plot extents, and turn off recalculation of mins, maxes, means, etc.
    ' after each time step. Be sure to turn that feature back ON when done with
    ' [DeferMinMaxCheck(0)], or those values will not be recalculated until the
    ' user does something to edit the data.
    sExec = "[ManualScale(" & Text1.Text & ")][AutoSize()][DeferMinMaxCheck(1)]"
    ret = DPlot_Command(DocNum, sExec)

'   Set labels:
    sExec = "[XAxisLabel(""Time (seconds)"")]"
    sExec = sExec & "[LegendParams(0.5,10,1,1,.05,.05)]"
    sExec = sExec & "[Legend(1,""SIN(t/4)"")]"
    sExec = sExec & "[Legend(2,""COS(t/4)"")]"
    sExec = sExec & "[Title1(""RealTime Demo"")]"
    sExec = sExec & "[Caption(""Visual Basic Demo"")]"
    ret = DPlot_Command(DocNum, sExec)

'   Tell DPlot not to update its menu (which normally would be done every
'   time [SelectCurve()] is used). This isn't strictly necessary, but
'   avoids annoying flashing from the menu and toolbar being continually
'   redrawn, and is a bit more efficient since, for the purposes of this
'   demo, the menu doesn't really need to be updated anyway. HOWEVER,
'   this setting is persistent. If you turn off menu updates then you
'   must eventually turn them back on. In the case of this example this
'   is done when the user stops the simulation and RealTimeStop is called.
    ret = DPlot_Command(DocNum, "[MenuUpdates(0)]")

'   Get start time from API function GetTickCount
    StartTicks = GetTickCount()

'   Enable the timer
    Timer1.Enabled = True
'
'   See Timer1_Timer procedure to see how data values are sent to DPLOT
'
    Exit Sub

RealTimeError:
    MsgBox "Cannot execute the command " & sExec, vbExclamation
    Exit Sub

End Sub

Private Sub Timer1_Timer()
    Dim x As Single
    Dim Y1 As Single
    Dim Y2 As Single
    Dim ret As Long
    
    Dim TT As Single
    Dim T As String
    
'   Use API function GetTickCount() to get actual time, since the timer can't
'   be relied on to post timer events at the interval we requested.
    x = CSng(GetTickCount() - StartTicks) / 1000#
    Y1 = Sin(x / 4)
    Y2 = Cos(x / 4)
    
'   The most efficient method for sending data to DPlot is highly dependent
'   on how many points are sent at once and how many curves are updated at
'   once. For this demo it's a wash; they're roughly equivalent. The
'   advantage of using DPlot_Command with an XY or XYXY command is that
'   multiple curves may be updated in a single call. The advantage of using
'   DPlot_AddData is that the data is sent in its native binary format, so
'   there's no need for translation to character string and back to binary.
'   For a large number of points this advantage becomes much more important.
'   DPlot_AddData also allows you to send an arbitrarily large number of
'   values; DPlot_Command is limited by the maximum command string length
'   (32768 characters).

    If (DrawMethod <> 0) Then
        ret = DPlot_AddData(DocNum, DATA_XYXY, 1, 1, x, Y1)
        If (ret > 0) Then
            ret = DPlot_AddData(DocNum, DATA_XYXY, 1, 2, x, Y2)
        End If
    Else
        sExec = "[SelectCurve(1)][XY(" + Str$(x) + "," + Str$(Y1) + ")]"
        sExec = sExec & "[SelectCurve(2)][XY(" + Str$(x) + "," + Str$(Y2) + ")]"
        ret = DPlot_Command(DocNum, sExec)
    End If
    
    If (ret <= 0) Then
        Call RealTimeStop
    Else
        Label3.Caption = Str$(x)
    End If
End Sub

