c
c Interface to DPLOTLIB functions
c
      STDCALL DPLOT_3DBORDER 'DPlot_3DBorder' (VAL, VAL, REF): INTEGER*4
      STDCALL DPLOT_ADDDATA 'DPlot_AddData' (VAL, VAL, VAL, VAL,
     &                          REF, REF): INTEGER*4
      STDCALL DPLOT_ADDDATA8 'DPlot_AddData8' (VAL, VAL, VAL, VAL,
     &                          REF, REF): INTEGER*4
      STDCALL DPLOT_COMMAND 'DPlot_Command' (VAL, INSTRING): INTEGER*4
      STDCALL DPLOT_GETBITMAP 'DPlot_GetBitmap' (VAL, VAL, VAL):
     &                          INTEGER*4
      STDCALL DPLOT_GETBITMAPEX 'DPlot_GetBitmapEx'
     &                          (VAL, VAL, VAL, REF): INTEGER*4
      STDCALL DPLOT_GETENHMETAFILE 'DPlot_GetEnhMetaFile'
     &                          (VAL, VAL, VAL): INTEGER*4
      STDCALL DPLOT_GETVERSION 'DPlot_GetVersion' (OUTSTRING): INTEGER*4
      STDCALL DPLOT_PLOT 'DPlot_Plot' (REF, REF, REF, INSTRING):
     &                          INTEGER*4
      STDCALL DPLOT_PLOT8 'DPlot_Plot8' (REF, REF, REF, INSTRING):
     &                          INTEGER*4
      STDCALL DPLOT_PLOT8P 'DPlot_Plot8p' (REF, VAL, VAL, INSTRING):
     &                          INTEGER*4
      STDCALL DPLOT_PLOTBITMAP 'DPlot_PlotBitmap' (REF, REF, REF,
     &                          INSTRING, VAL, VAL): INTEGER*4
      STDCALL DPLOT_PLOTBITMAP8 'DPlot_PlotBitmap8' (REF, REF, REF,
     &                          INSTRING, VAL, VAL): INTEGER*4
      STDCALL DPLOT_PLOTTORECT 'DPlot_PlotToRect' (REF, REF, REF,
     &                          INSTRING, VAL, REF): INTEGER*4
      STDCALL DPLOT_PLOTTORECT8 'DPlot_PlotToRect8' (REF, REF, REF,
     &                          INSTRING, VAL, REF): INTEGER*4
      STDCALL DPLOT_REQUEST 'DPlot_Request' (VAL, INSTRING, OUTSTRING,
     &                          REF): INTEGER*4
      STDCALL DPLOT_SETERRORMETHOD 'DPlot_SetErrorMethod' (VAL)
      STDCALL DPLOT_START 'DPlot_Start' (VAL, REF): INTEGER*4
      STDCALL DPLOT_STOP 'DPlot_Stop'
      STDCALL DPLOT_ZFROMXY 'DPlot_ZFromXY' (VAL, VAL, VAL, REF):
     &                          INTEGER*4

c
      integer DPLOT_DDE_VERSION
      parameter (DPLOT_DDE_VERSION=2)

        integer*4 DPVersion                       ! version number of this structure
        integer*4 DPhwnd                          ! handle of client application window
        integer*4 DPDataFormat            ! XY pairs, DX and Y, etc.
        integer*4 DPMaxCurves                     ! maximum number of curves (must be <= 20)
        integer*4 DPMaxPoints                     ! maximum number of points/curve
        integer*4 DPNumCurves                     ! actual number of curves, always 1 for DATA_3D or DATA_3DR
        integer*4 DPScale                         ! scaling code (Linear, Log, etc.)
        real*4    DPLegendX                       ! left coord of legend, expressed as a ratio of plot size (0->1)
        real*4    DPLegendY                       ! top coord of legend
        integer*4 DPNP(20)                        ! actual number of points in each curve, cannot exceed MaxPoints.
        integer*4 DPLineType(20)          ! line types (see codes below)
        integer*4 DPSymbolType(20)        ! symbol types (see codes below)
        integer*4 DPSizeofExtraInfo
        character DPLegend(0:20)*40
        character DPLabel(20)*5
        character DPTitle(3)*80
        character DPXAxis*80
        character DPYAxis*80
      Common /DPLOT/ DPVersion, DPhwnd, DPDataFormat, DPMaxCurves, 
     &               DPMaxPoints, DPNumCurves, DPScale, DPLegendX,
     &               DPLegendY, DPNP, DPLineType, 
     &               DPSymbolType, DPSizeofExtraInfo, 
     &               DPLegend, DPLabel, DPTitle,
     &               DPXAxis, DPYAxis

c Scaling codes:

      integer*4 SCALE_LINEARX_LINEARY
      integer*4 SCALE_LINEARX_LOGY
      integer*4 SCALE_LOGX_LINEARY
      integer*4 SCALE_LOGX_LOGY
      integer*4 SCALE_TRIPARTITE
      integer*4 SCALE_LINEARX_PROBABILITY
      integer*4 SCALE_GRAINSIZE_DIST
      integer*4 SCALE_POLAR
      integer*4 SCALE_BARCHART
      integer*4 SCALE_LOGX_PROBABILITY
      integer*4 SCALE_PROBX_LINEARY
      integer*4 SCALE_PROBX_LOGY
      integer*4 SCALE_PROBX_PROBY
      integer*4 SCALE_TRIANGLE_PLOT
      integer*4 SCALE_N185
      parameter (SCALE_LINEARX_LINEARY    = 1)
      parameter (SCALE_LINEARX_LOGY       = 2)
      parameter (SCALE_LOGX_LINEARY       = 3)
      parameter (SCALE_LOGX_LOGY          = 4)
      parameter (SCALE_TRIPARTITE         = 5)
      parameter (SCALE_LINEARX_PROBABILITY= 6)
      parameter (SCALE_GRAINSIZE_DIST     = 7)
      parameter (SCALE_POLAR              = 8)
      parameter (SCALE_BARCHART           = 9)
      parameter (SCALE_LOGX_PROBABILITY   =10)
      parameter (SCALE_PROBX_LINEARY      =11)
      parameter (SCALE_PROBX_LOGY         =12)
      parameter (SCALE_PROBX_PROBY        =13)
      parameter (SCALE_TRIANGLE_PLOT      =14)
      parameter (SCALE_N185               =15)

c Unit-specific scaling codes ... combine with above values using OR operator
      integer*4 UNITS_DEFAULT
      integer*4 UNITS_TRIPARTITE_INCHES
      integer*4 UNITS_TRIPARTITE_FEET
      integer*4 UNITS_TRIPARTITE_MILLIMETERS
      integer*4 UNITS_TRIPARTITE_CENTIMETERS
      integer*4 UNITS_TRIPARTITE_METERS
      integer*4 UNITS_GRAINSIZE_MILLIMETERS
      integer*4 UNITS_GRAINSIZE_INCHES
      integer*4 UNITS_POLAR_RADIANS
      integer*4 UNITS_POLAR_DEGREES
      integer*4 UNITS_USERDEFINED
      parameter (UNITS_DEFAULT                =0)
      parameter (UNITS_TRIPARTITE_INCHES      =UNITS_DEFAULT)   ! Velocity (Y) in inches/sec
      parameter (UNITS_TRIPARTITE_FEET        =  256  )   !                 feet/sec
      parameter (UNITS_TRIPARTITE_MILLIMETERS =  512  )   !                 mm/sec
      parameter (UNITS_TRIPARTITE_CENTIMETERS =  768  )   !                 cm/sec
      parameter (UNITS_TRIPARTITE_METERS      = 1024  )   !                 meters/sec
      parameter (UNITS_GRAINSIZE_MILLIMETERS  =UNITS_DEFAULT)   ! Grain sizes (X) in mm
      parameter (UNITS_GRAINSIZE_INCHES       =  256  )   !                    inches
      parameter (UNITS_POLAR_RADIANS          =UNITS_DEFAULT)   ! Rotation (X) in radians
      parameter (UNITS_POLAR_DEGREES          =  256  )   !                 degrees
      parameter (UNITS_USERDEFINED            =32512  )

c Data organization following DPLOT structure in XTYP_POKE transactions:

      integer*4 DATA_XYXY
      integer*4 DATA_DXY
      integer*4 DATA_XYYY
      integer*4 DATA_3D
      integer*4 DATA_3DR
      integer*4 DATA_IMAGE
      integer*4 DATA_1D
      parameter (DATA_XYXY         =0)
      parameter (DATA_DXY          =1)
      parameter (DATA_XYYY         =2)
      parameter (DATA_3D           =3)  ! Z values on a rectangular grid
      parameter (DATA_3DR          =4)  ! Random X,Y,Z values
      parameter (DATA_IMAGE        =5)  ! Used only by DPlot - there's no way to SEND DPlot an image
      parameter (DATA_1D           =6)

c Line styles:

      integer*4 LINESTYLE_NONE
      integer*4 LINESTYLE_SOLID
      integer*4 LINESTYLE_LONGDASH
      integer*4 LINESTYLE_DOTTED
      integer*4 LINESTYLE_DASHDOT
      integer*4 LINESTYLE_MEDDASH
      integer*4 LINESTYLE_DASHDOTDOT
      parameter (LINESTYLE_NONE        =0)
      parameter (LINESTYLE_SOLID       =1)
      parameter (LINESTYLE_LONGDASH    =2)
      parameter (LINESTYLE_DOTTED      =3)
      parameter (LINESTYLE_DASHDOT     =4)
      parameter (LINESTYLE_MEDDASH     =5)
      parameter (LINESTYLE_DASHDOTDOT  =6)

c Symbol styles
      integer*4 SYMBOLSTYLE_NONE
      integer*4 SYMBOLSTYLE_DOT
      integer*4 SYMBOLSTYLE_CROSS
      integer*4 SYMBOLSTYLE_ASTERISK
      integer*4 SYMBOLSTYLE_X
      integer*4 SYMBOLSTYLE_SQUARE
      integer*4 SYMBOLSTYLE_DIAMOND
      integer*4 SYMBOLSTYLE_TRIANGLE
      integer*4 SYMBOLSTYLE_OCTAGON
      integer*4 SYMBOLSTYLE_ITRIANGLE
      integer*4 SYMBOLSTYLE_HEXAGON
      integer*4 SYMBOLSTYLE_PENTAGON
      integer*4 SYMBOLSTYLE_STAR
      integer*4 SYMBOLSTYLE_FILL
      parameter (SYMBOLSTYLE_NONE        = 0)
      parameter (SYMBOLSTYLE_DOT         = 1)
      parameter (SYMBOLSTYLE_CROSS       = 2)
      parameter (SYMBOLSTYLE_ASTERISK    = 3)
      parameter (SYMBOLSTYLE_X           = 4)
      parameter (SYMBOLSTYLE_SQUARE      = 5)
      parameter (SYMBOLSTYLE_DIAMOND     = 6)
      parameter (SYMBOLSTYLE_TRIANGLE    = 7)
      parameter (SYMBOLSTYLE_OCTAGON     = 8)
      parameter (SYMBOLSTYLE_ITRIANGLE   = 9)
      parameter (SYMBOLSTYLE_HEXAGON     =10)
      parameter (SYMBOLSTYLE_PENTAGON    =11)
      parameter (SYMBOLSTYLE_STAR        =12)
      parameter (SYMBOLSTYLE_FILL        =256)

c
